// Player1.cpp: implementation of the CPlayer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "player.h"
#include "Player1.h"
#include "MainFrm.h"
#include "playerView.h"
#include <string>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CPlayer* CPlayer::_instance = 0;

int nTrackNumber = 1;

CPlayer::CPlayer():
m_timeTrack(0),
m_strTitle("Ready"),
y0(0),
m_strFile("mus/1.wav")
{

}

CPlayer::~CPlayer()
{

}

void CPlayer::OnDraw(CDC *pDC)
{
	CMainFrame *pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CPlayerView *pView = (CPlayerView*) pFrame->GetActiveView();
	CRect rect(CPoint(0,0), m_size);
	pDC->FillSolidRect(rect, RGB(200,200,250));
	CPen *pen_old = pDC->GetCurrentPen();
	CPen *pen_black = new CPen(PS_SOLID, 1, RGB(0,0,0));
	CPen *pen_red = new CPen(PS_SOLID, 2, RGB(255,0,0));
	pDC->SelectObject(pen_black);
	for (int i = 0; i < 5; i++)
	{
		rect.right = i*(m_size.cx+0.5)/5;
		rect.left = rect.right + (m_size.cx+0.5)/5;
		rect.bottom = m_size.cy-3;
		rect.top = rect.bottom - m_size.cy/8;

		rect.InflateRect(4, 2, 4, 2);
		pDC->Rectangle(rect);
		rect.InflateRect(3, -3, 3, -3);
		pDC->FillSolidRect(rect, RGB(100,100,150));
		pDC->SelectObject(pen_red);
		rect.NormalizeRect();
		CPoint pt(rect.Width()/2, rect.Height()/2);
		pt.x = rect.left + rect.Width()/2;
		pt.y = rect.top + rect.Height()/2;
		pDC->MoveTo(pt);

		switch(i) 
		{
		case 0: //play
			pt.y -=4;
			pDC->LineTo(pt);
			pt.x +=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.x -=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.y -= 4;
			pDC->LineTo(pt);
			break;
		case 1: //stop
			pt.y -=4;
			pDC->LineTo(pt);
			pt.x +=8; pt.y += 0;
			pDC->LineTo(pt);
			pt.x -=0; pt.y += 8;
			pDC->LineTo(pt);
			pt.x -=8; pt.y += 0;
			pDC->LineTo(pt);
			pt.y -= 4;
			pDC->LineTo(pt);
			
			break;
		case 2: //pause
			pt.x -= 4; pt.y -=4;
			pDC->MoveTo(pt);
			pt.y += 8;
			pDC->LineTo(pt);
			pt.x += 8;
			pDC->MoveTo(pt);
			pt.y -= 8;
			pDC->LineTo(pt);
			break;
		case 3: //prev
			pt.x += 8;
			pDC->MoveTo(pt);
			pt.y -=4;
			pDC->LineTo(pt);
			pt.x -=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.x +=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.y -= 4;
			pDC->LineTo(pt);
			
			pt.x -= 8;
			pDC->MoveTo(pt);
			pt.y -=4;
			pDC->LineTo(pt);
			pt.x -=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.x +=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.y -= 4;
			pDC->LineTo(pt);
			
			break;
		case 4: //next
			pt.x -= 8;
			pDC->MoveTo(pt);
			pt.y -=4;
			pDC->LineTo(pt);
			pt.x +=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.x -=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.y -= 4;
			pDC->LineTo(pt);
			
			pt.x += 8;
			pDC->MoveTo(pt);
			pt.y -=4;
			pDC->LineTo(pt);
			pt.x +=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.x -=8; pt.y += 4;
			pDC->LineTo(pt);
			pt.y -= 4;
			pDC->LineTo(pt);
			break;
		}
		pDC->SelectObject(pen_old);
	}
	CRect rect_view(m_size.cx / 16, m_size.cy / 16, m_size.cx - m_size.cx / 16 , m_size.cy - m_size.cy / 3);
	pDC->FillSolidRect(rect_view, RGB(10,10,10));

	delete pen_black;
	delete pen_red;

	DrawTitles(rect_view, pDC);
}
CPlayer *const CPlayer::Instance()
{
	if (_instance == 0) _instance = new CPlayer ;
	return _instance;
}

void CPlayer::DeleteClass()
{
	delete _instance;
	_instance = 0;
}

void CPlayer::SetNewSize(CSize size)
{
	m_size = size;
}

CSize CPlayer::GetSize() const
{
	return m_size;

}

void CPlayer::DrawTitles(CRect rect, CDC *pDC)
{
	CFont fntTime, fntTrack;
	fntTime.CreateFont(rect.Height()/2, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, "Courier");
	fntTrack.CreateFont(rect.Height()/5, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, "Arial");
	pDC->SetTextColor(RGB(50, 250, 50));
	pDC->SelectObject(&fntTime);
	//pDC->DrawText(m_timeTrack.Format("%M:%S"), rect, 0);
	pDC->DrawText(m_strFile.c_str(), rect, 0);
	pDC->SelectObject(&fntTrack);
	CRect rect_title = rect;
	rect_title.top += rect_title.Height()*2/3;
	pDC->DrawText(m_strTitle, rect_title, 0);
	
	
	
}

void CPlayer::A0(int e)
{
	
	int yold = y0;
	
	switch(y0)
	{
	case 0: // "  "
		
		if(e == 3) { y0 = 3; }		// FF	
		if(e == 6) { y0 = 1; }		// no tracks
		if(e == 1) { y0 = 2; }		// play
		break;

	case 1: // " "
		//   .    -  . //   
		break;

	case 2: // " "
		if(e == 5) { y0 = 5; }		// pause 
		if(e == 4) { y0 = 4; }		// REW
		if(e == 3) { y0 = 3; }		// FF
		if(e == 2) { y0 = 0; }		// stop
		break;

	case 3: // "  "
		{ y0 = 2; }					// play
		break;

	case 4: // "  "
		{ y0 = 2; }					// play
		break;
	
	case 5: // ""
		if (e == 5)	{ y0 = 2; }		// Continue playing after PAUSE pressed
		if (e == 1)	{ y0 = 2; }		// Continue playing after PLAY pressed
		if (e == 2)	{ y0 = 0; }		// Stop anyway
		if (e == 3) { y0 = 3; }		// Track forward,then play
		if (e == 4) { y0 = 4; }		// Track backward, then play
		break;
	}
	
	if(y0 != yold)
	{
		switch(y0)
		{
		case 0:
			{ z1(); } // ready = disk is stopped
			break;
		case 1:
			{ z6(); } // no track	
			break;
		case 2:
			{ z2(); } // play 
			break;
		case 3:
			{ z3();}  // FF
			break;
		case 4:       // REW
			{ z4(); }
			break;
		case 5:		  // PAUSE
			{ z5(); }
			break;
		}
	}
	
}

//  
// READY = STOPPED
void CPlayer::z1()
{
	m_timeTrack = 0;

	nTrackNumber = 1;
	//i_Sound.StopSoundFile();
	m_strTitle = "Track 1. Ready" ;
	CMainFrame *pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CPlayerView *pView = (CPlayerView*) pFrame->GetActiveView();
	pView->Invalidate();
	m_s.StopSoundFile();
	
}

// PLAY
void CPlayer::z2()
{
	CString strNum;
	strNum.Format("%d", nTrackNumber);
	m_strTitle = "Track " + strNum + ". Playing" ;
	CMainFrame *pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CPlayerView *pView = (CPlayerView*) pFrame->GetActiveView();
	pView->Invalidate();
	m_s.PlaySoundFile(const_cast<char*>(m_strFile.c_str()));
}

// FF
void CPlayer::z3()
{

	if (nTrackNumber < m_nMaxNumber) {
		nTrackNumber++;
		CString str;
		str.Format("%d", nTrackNumber);
		m_strFile = "mus/" + str + ".wav";
	}
	A0(0); // continue playing ( )
	
}

// REW
void CPlayer::z4()
{
	if (nTrackNumber > 0) {
		if (nTrackNumber > 1)
		{ nTrackNumber--; }
		CString str;
		str.Format("%d", nTrackNumber);
		m_strFile = "mus/" + str + ".wav";
	}
		
	A0(0);

}

// PAUSE
void CPlayer::z5()
{
	CString strNum;
	strNum.Format("%d", nTrackNumber);
	m_strTitle = "Track " + strNum + ". Paused" ;
	

	CMainFrame *pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CPlayerView *pView = (CPlayerView*) pFrame->GetActiveView();
	m_s.StopSoundFile();
	pView->Invalidate();
}

// NO TRACK
void CPlayer::z6()
{
	m_strTitle = "NO TRACK";

	
	CMainFrame *pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CPlayerView *pView = (CPlayerView*) pFrame->GetActiveView();
	pView->Invalidate();
}


void CPlayer::BtnPlayPressed()
{
	A0(1);
}

void CPlayer::BtnStopPressed()
{
	A0(2);
}

void CPlayer::BtnNextPressed()
{
	A0(3);
}

void CPlayer::BtnPrevPressed()
{
	A0(4);	
}

void CPlayer::BtnPausePressed()
{
	A0(5);
}

//  .
// -       .
//  ,   ,     . 
void CPlayer::FindNoTracks()
{
	A0(6);
}

BEGIN_MESSAGE_MAP(CPlayer, CWnd)
//{{AFX_MSG_MAP(CPlayer)
ON_WM_TIMER()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CPlayer::OnTimer(UINT nIDEvent) 
{
//	KillTimer(nIDEvent);
	if(nIDEvent == 1000)
	{
	int i = 0;		
	};//long_time_elapsed();
}

void CPlayer::SetNumberOfTracks(int nNumber)
{
	m_nMaxNumber = nNumber;
}
