// playerView.cpp : implementation of the CPlayerView class
//

#include "stdafx.h"
#include "player.h"

#include "playerDoc.h"
#include "playerView.h"
#include "player1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayerView

IMPLEMENT_DYNCREATE(CPlayerView, CView)

BEGIN_MESSAGE_MAP(CPlayerView, CView)
	//{{AFX_MSG_MAP(CPlayerView)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerView construction/destruction

CPlayerView::CPlayerView()
{

}

CPlayerView::~CPlayerView()
{
	CPlayer::DeleteClass();
}

BOOL CPlayerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerView drawing

void CPlayerView::OnDraw(CDC* pDC)
{
	CPlayerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	CPlayer::Instance()->OnDraw(pDC);

}

/////////////////////////////////////////////////////////////////////////////
// CPlayerView printing

BOOL CPlayerView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPlayerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPlayerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerView diagnostics

#ifdef _DEBUG
void CPlayerView::AssertValid() const
{
	CView::AssertValid();
}

void CPlayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPlayerDoc* CPlayerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPlayerDoc)));
	return (CPlayerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPlayerView message handlers

int xOld = 200;
int yOld = 200;

void CPlayerView::OnSize(UINT nType, int cx, int cy) 
{

	CView::OnSize(nType, cx, cy);
	CPlayer::Instance()->SetNewSize(CSize(cx, cy));
		
}


void CPlayerView::OnFinalRelease() 
{
	
	CView::OnFinalRelease();
}

BOOL CPlayerView::OnEraseBkgnd(CDC* pDC) 
{
	return true;
	return CView::OnEraseBkgnd(pDC);
}

void CPlayerView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	
	
	
	switch(CheckMouseDown(point)) {
	case 0:
		CPlayer::Instance()->BtnPlayPressed();
		break;
	case 1:
		CPlayer::Instance()->BtnStopPressed();
		break;
	case 2:
		CPlayer::Instance()->BtnPausePressed();
		break;
	case 3:
		CPlayer::Instance()->BtnPrevPressed();
		break;
	case 4:
		CPlayer::Instance()->BtnNextPressed();
		break;
	}

	CView::OnLButtonDown(nFlags, point);
}

int CPlayerView::CheckMouseDown(CPoint pt)
{

	CSize size = CPlayer::Instance()->GetSize();
	if ((pt.y > (size.cy - size.cy/8))&& pt.y < size.cy)
		for (int i = 0; i < 5; ++i)
		{
			if ((i*size.cx/5 < pt.x) && (pt.x < (i+1)*size.cx/5))
				return i;
		}

	return -1;	
}


void CPlayerView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	
	// ,      

	int k = 0;
	CString str = "";
	CString sName = "";
	HANDLE hFile;
	for(k = 1; k < 100; k++)
	{
		str.Format("%d", k);
		sName = "mus/" + str + ".wav";		

		hFile = CreateFile(sName,
		     GENERIC_READ, FILE_SHARE_READ,
			 NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

		if (hFile == INVALID_HANDLE_VALUE)
  			break;
		else
			CloseHandle(hFile);   
		
	}

	k--;
	
	if (k == 0)
		CPlayer::Instance()->FindNoTracks();	
	else
		CPlayer::Instance()->SetNumberOfTracks(k);	

	
}


